COMMENT -

	Description: Application to test EnumResourceNames
	Date: 27 March 2008
	
-

.386 					
.model 		flat, stdcall
option 		casemap: none

include windows.inc
include user32.inc
include kernel32.inc

includelib user32.lib
includelib kernel32.lib

ErrMsg proto :DWORD,:DWORD,:DWORD,:DWORD
EnumResProc proto :DWORD, :DWORD, :DWORD, :DWORD

.const

.data

	szErrorFormat db 'Error Code: %i',13,10,13,10,'%s',13,10,'Error ID: %i',0
	szAppName db 'Test Application',0

.data?

.code


Win32:

	invoke EnumResourceNames,NULL,RT_STRING,addr EnumResProc,0
	.if eax == 0
		invoke ErrMsg,NULL,122,0,NULL		
		mov eax,1
		ret		
	.endif

	invoke ExitProcess,0


EnumResProc proc hModule:DWORD, lpType:DWORD, lpName:DWORD, lParam:DWORD
		
	invoke MessageBox,0,[lpName],addr szAppName,MB_OK
	
	mov eax,TRUE
	ret
EnumResProc endp

ErrMsg proc hW:HWND, icode:DWORD, itype:DWORD, phead:DWORD
	
	local lbuffer:DWORD
	local mbuffer[256]:BYTE
	local dwError:DWORD
	
	.if itype == 0
		invoke GetLastError
	.else
		invoke GetLastError
	.endif
	
	mov dwError,eax
	
	lea eax, [lbuffer]
	invoke FormatMessage,FORMAT_MESSAGE_ALLOCATE_BUFFER + FORMAT_MESSAGE_FROM_SYSTEM,0,[dwError],LANG_NEUTRAL,eax,0,0
	invoke wsprintf,addr mbuffer,addr szErrorFormat,[dwError],[lbuffer],icode
	invoke MessageBox,NULL,addr mbuffer,addr szAppName,MB_ICONERROR+MB_OK
	invoke LocalFree,[lbuffer]
	
	xor eax, eax
	ret
ErrMsg endp

end Win32